<?php

namespace TranslationBundle\Repository;

use Schema\SchemaEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;
use TranslationBundle\Entity\Translation;
use Utils\StaticUtil\LogUtils;

/**
 * TranslationRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class TranslationRepository extends SchemaEntityRepository {


    ///////////////////////////////////////////
    /// CONSTRUCTOR

    /**
     * @param ManagerRegistry $registry
     */
    public function __construct(ManagerRegistry $registry) {
        parent::__construct($registry, Translation::class);
    }


    /**
     * @param $sources
     * @param $lang
     * @return mixed|null
     */
    public function findBySources($sources, $lang) {
        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('t.source, t.value')
            ->from('TranslationBundle:Translation', 't')
            ->where('t.lang = :lang AND t.source IN (:sources)')
            ->setParameter('lang', $lang)
            ->setParameter('sources', $sources);

        $results = null;

        try {
            $results = $qb->getQuery()->getResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            //TODO: add log
        }

        return $results;
    }


    public function findAllResults() {
        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('t.source, t.value')
            ->from('TranslationBundle:Translation', 't');

        $results = null;

        try {
            $results = $qb->getQuery()->getResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            //TODO: add log
        }

        return $results;
    }

}
